#!/usr/bin/env python
#-*- coding: iso-8859-15 -*-

import random
import sys, os
import pygame
import copy
from language import *
import colorsys

class Capturar:
    def __init__(self):
        #OTROS POSIBLES COLORES
        #(0, 0, 0, 255), (130, 0, 130, 255), (130, 130, 130, 255)]
        self.colores = lll.colores
        self.capas = [ [],[],[],[],[],[] ]
        self.resolucion = [ [],[],[],[],[],[] ]
        
    def capturarCaras(self):
        cont = 0
        for capas in self.capas:
            sys.stdout.write(os.popen('clear').read())    
            for cara in range(6):
                print self.colores[cara][0], self.colores[cara][1]
            
            apto = False
            comprobarColores = True
            while not apto: #TODO TODO no se puede comprobar los colores sin 
                            #antes modificar, pero modificando la liamos
                string = "cara %d --> " %(cont)
                #cadena = raw_input(string)
                cadena = 9*str(cont)    #PRUEBAS TODO
                
                for contColor in range(5): #comprobando 9 colores/color
                    if self.colores[contColor][1] < 0:
                        comprobarColores = False
                        print lll.error3

                if cadena.isdigit() and len(cadena) == 9 and comprobarColores:
                    for color in range(9):  #contando y añadiendo colores
                        self.colores[int(cadena[color])][1] -=1
                        cadenaColor = self.colores[int(cadena[color])][0]
                        capas.append( cadenaColor[0] )
                        
                    apto = True
                    cont += 1
    

    def getCapas(self):
        """Devuelve los colores que tiene cada capa del cubo"""
        return self.capas

    ############
    def mov(self, *mov):
        """recibe como entrada movimientos para mover el cubo. Ej: 'L', 'R2'
        Ejemplos de movimientos estando el cubo hecho: 
        #anaconda = ("L","U","B'","U'","R","L'","B","R'","F","B'","D","R","D'","F'")
        #cubodentrotro = ("F","L","F","U'","R","U","F2","L2","U'","L'","B","D'","B'","L2","U")
        #cruces = ("F","F","B","B","D","D","U","U","R","R","L","L")
        """        
        change = (2, 5, 8, 1, 4, 7, 0, 3, 6)
        
        for gen in mov:
            if gen[0] == lll.movs[0]: part1 = 0
            elif gen[0] == lll.movs[12]: part1 = 1
            elif gen[0] == lll.movs[3]: part1 = 2
            elif gen[0] == lll.movs[9]: 
                part1 = 3
                change = (6, 3, 0, 7, 4, 1, 8, 5, 2)
            elif gen[0] == lll.movs[15]: part1 = 4
            elif gen[0] == lll.movs[6]: 
                part1 = 5
                change = (6, 3, 0, 7, 4, 1, 8, 5, 2)
            else: print lll.error2
            
            part2 = 1
            if len(gen) == 2:
                if gen[1].isdigit():
                    part2 = 2
                else:
                    part2 = 3
            
            cont = 0
            while part2 > 0:
                self.antCapas = copy.deepcopy(self.capas)

                for c in range(9):
                    self.capas[part1][c] = self.antCapas[part1][change[c]]
                
                if part1 == 0: #U
                    ar1 = (1,1,1,3,3,3,4,4,4,5,5,5)
                    ar2 = (0,1,2,0,1,2,0,1,2,0,1,2)
                elif part1 == 1: #F tick
                    ar1 = (2,2,2,3,3,3,0,0,0,5,5,5)
                    ar2 = (0,1,2,6,3,0,8,7,6,2,5,8)
                elif part1 == 2: #D tick
                    ar1 = (4,4,4,3,3,3,1,1,1,5,5,5)
                    ar2 = (6,7,8,6,7,8,6,7,8,6,7,8)
                elif part1 == 3: #R
                    ar1 = (2,2,2,4,4,4,0,0,0,1,1,1)
                    ar2 = (2,5,8,6,3,0,2,5,8,2,5,8)
                elif part1 == 4: #B tick
                    ar1 = (2,2,2,5,5,5,0,0,0,3,3,3)
                    ar2 = (8,7,6,6,3,0,0,1,2,2,5,8)
                elif part1 == 5: #L
                    ar1 = (0,0,0,4,4,4,2,2,2,1,1,1)
                    ar2 = (6,3,0,2,5,8,6,3,0,6,3,0)
                
                for a in range(len(ar1)):
                    b = (a+3) % len(ar1)
                    self.capas[ar1[a]][ar2[a]] = self.antCapas[ar1[b]][ar2[b]]
                            
                part2 -= 1
                
    ########
    def pintarCubo(self, NumberOrColor = 0):
        """pinta las capas de self.capas con pygame"""
        self.window = pygame.display.set_mode((800, 600))
        pygame.display.set_caption("PyRubik")

        #variables
        m = (95, 95, 95, 190, 285, 0)
        n = (0, 95, 190, 95, 95, 95)
        a = (0, 30, 60)
        
        #recorremos todos los colores captados para pintarlo en pantalla
        for x in range(len(self.capas)):
            for w in range(len(self.capas[x])): #TODO
                if NumberOrColor == 0:  #pinta por num
                    pygame.draw.rect(self.window, self.colores[int(self.capas[x][w])][2],\
                     (a[w%3]+m[x], a[w//3]+n[x], 30, 30))
                else:   #pinta por colores
                    pygame.draw.rect(self.window, self.capas[x][w], (a[w%3]+m[x], a[w//3]+n[x], 30, 30))
    
                #hls = colorsys.rgb_to_hls(*map(lambda x: x/255.0, self.capas[x][w][0:3])) #RGB to HLS

    ########
    def guardar(self, name):
        """guarda lo mostrado en pantalla por pygame"""
        pygame.image.save(self.window, name)
        pygame.display.flip()
        pygame.quit()

    #######    
    def resolver(self):
        pass
    
    
    def sacarColoresDeImagen(self):
        """obtenemos los colores de dos imagenes hechas con la malla1.png"""
        pygame.init()
        pygame.display.init()

        imagen = pygame.image.load("capa1.png")
        imagen2 = pygame.image.load("capa2.png")

        screen = pygame.display.set_mode( (400, 300) )
        pygame.display.set_caption( 'PyRubik' )

        X = imagen.get_width()
        Y = imagen.get_height()
        centerx =  X/2
        centery =  Y/2

        X2 = imagen2.get_width()
        Y2 = imagen2.get_height()
        centerx2 =  X2/2
        centery2 =  Y2/2

        #cogemos los colores de las distintas capas #TODO sacar 4 colores de cada capa
        self.capas[0].append(imagen.get_at((int(1.0/6*X), int(3.0/12*Y))))
        self.capas[0].append(imagen.get_at((int(2.0/6*X), int(2.0/12*Y))))
        self.capas[0].append(imagen.get_at((centerx, int(1.0/12*Y))))
        self.capas[0].append(imagen.get_at((int(2.0/6*X), int(4.0/12*Y))))
        self.capas[0].append(imagen.get_at((centerx, int(3.0/12*Y))))
        self.capas[0].append(imagen.get_at((int(4.0/6*X), int(2.0/12*Y))))
        self.capas[0].append(imagen.get_at((centerx, int(5.0/12*Y))))
        self.capas[0].append(imagen.get_at((int(4.0/6*X), int(4.0/12*Y))))
        self.capas[0].append(imagen.get_at((int(5.0/6*X), int(3.0/12*Y))))
        
        self.capas[1].append(imagen.get_at((centerx + int(1.0/12*X), centery + int(1.0/24*Y))))
        self.capas[1].append(imagen.get_at((centerx + int(3.0/12*X), centery - int(1.0/24*Y))))
        self.capas[1].append(imagen.get_at((centerx + int(5.0/12*X), centery - int(3.0/24*Y))))
        self.capas[1].append(imagen.get_at((centerx + int(1.0/12*X), centery + int(5.0/24*Y))))
        self.capas[1].append(imagen.get_at((centerx + int(3.0/12*X), centery + int(3.0/24*Y))))
        self.capas[1].append(imagen.get_at((centerx + int(5.0/12*X), centery + int(1.0/24*Y))))
        self.capas[1].append(imagen.get_at((centerx + int(1.0/12*X), centery + int(9.0/24*Y))))
        self.capas[1].append(imagen.get_at((centerx + int(3.0/12*X), centery + int(7.0/24*Y))))
        self.capas[1].append(imagen.get_at((centerx + int(5.0/12*X), centery + int(5.0/24*Y))))
        
        self.capas[2].append(imagen2.get_at((centerx2, int(1.0/12*Y2))))
        self.capas[2].append(imagen2.get_at((int(4.0/6*X2), int(2.0/12*Y2))))
        self.capas[2].append(imagen2.get_at((int(5.0/6*X2), int(3.0/12*Y2))))
        self.capas[2].append(imagen2.get_at((int(2.0/6*X2), int(2.0/12*Y2))))
        self.capas[2].append(imagen2.get_at((centerx2, int(3.0/12*Y2))))
        self.capas[2].append(imagen2.get_at((int(4.0/6*X2), int(4.0/12*Y2))))
        self.capas[2].append(imagen2.get_at((int(1.0/6*X2), int(3.0/12*Y2))))
        self.capas[2].append(imagen2.get_at((int(2.0/6*X2), int(4.0/12*Y2))))
        self.capas[2].append(imagen2.get_at((centerx2, int(5.0/12*Y2))))

        self.capas[3].append(imagen2.get_at((centerx2 + int(5.0/12*X2), centery2 + int(5.0/24*Y2))))
        self.capas[3].append(imagen2.get_at((centerx2 + int(3.0/12*X2), centery2 + int(7.0/24*Y2))))
        self.capas[3].append(imagen2.get_at((centerx2 + int(1.0/12*X2), centery2 + int(9.0/24*Y2))))
        self.capas[3].append(imagen2.get_at((centerx2 + int(5.0/12*X2), centery2 + int(1.0/24*Y2))))
        self.capas[3].append(imagen2.get_at((centerx2 + int(3.0/12*X2), centery2 + int(3.0/24*Y2))))
        self.capas[3].append(imagen2.get_at((centerx2 + int(1.0/12*X2), centery2 + int(5.0/24*Y2))))
        self.capas[3].append(imagen2.get_at((centerx2 + int(5.0/12*X2), centery2 - int(3.0/24*Y2))))
        self.capas[3].append(imagen2.get_at((centerx2 + int(3.0/12*X2), centery2 - int(1.0/24*Y2))))
        self.capas[3].append(imagen2.get_at((centerx2 + int(1.0/12*X2), centery2 + int(1.0/24*Y2))))

        self.capas[4].append(imagen2.get_at((centerx2 - int(1.0/12*X2), centery2 + int(9.0/24*Y2))))
        self.capas[4].append(imagen2.get_at((centerx2 - int(3.0/12*X2), centery2 + int(7.0/24*Y2))))
        self.capas[4].append(imagen2.get_at((centerx2 - int(5.0/12*X2), centery2 + int(5.0/24*Y2))))
        self.capas[4].append(imagen2.get_at((centerx2 - int(1.0/12*X2), centery2 + int(5.0/24*Y2))))
        self.capas[4].append(imagen2.get_at((centerx2 - int(3.0/12*X2), centery2 + int(3.0/24*Y2))))
        self.capas[4].append(imagen2.get_at((centerx2 - int(5.0/12*X2), centery2 + int(1.0/24*Y2))))
        self.capas[4].append(imagen2.get_at((centerx2 - int(1.0/12*X2), centery2 + int(1.0/24*Y2))))
        self.capas[4].append(imagen2.get_at((centerx2 - int(3.0/12*X2), centery2 - int(1.0/24*Y2))))
        self.capas[4].append(imagen2.get_at((centerx2 - int(5.0/12*X2), centery2 - int(3.0/24*Y2))))

        self.capas[5].append(imagen.get_at((centerx - int(5.0/12*X), centery - int(3.0/24*Y))))
        self.capas[5].append(imagen.get_at((centerx - int(3.0/12*X), centery - int(1.0/24*Y))))
        self.capas[5].append(imagen.get_at((centerx - int(1.0/12*X), centery + int(1.0/24*Y))))
        self.capas[5].append(imagen.get_at((centerx - int(5.0/12*X), centery + int(1.0/24*Y))))
        self.capas[5].append(imagen.get_at((centerx - int(3.0/12*X), centery + int(3.0/24*Y))))
        self.capas[5].append(imagen.get_at((centerx - int(1.0/12*X), centery + int(5.0/24*Y))))
        self.capas[5].append(imagen.get_at((centerx - int(5.0/12*X), centery + int(5.0/24*Y))))
        self.capas[5].append(imagen.get_at((centerx - int(3.0/12*X), centery + int(7.0/24*Y))))
        self.capas[5].append(imagen.get_at((centerx - int(1.0/12*X), centery + int(9.0/24*Y))))
    
    def capturarColores6Capas(self, HSL = False):
        """Captura los colores capa a capa."""
        
        self.capas = [ [],[],[],[],[],[] ]
        pos = ((0,0),(0,160),(160,160),(320, 160),(480,160),(480,320))
        xxx = (1, 3, 5)
        
        for capa in range(len(self.capas)):
            cont = 0
            pix = []
            while cont < 9:
                pix.append( ( 27*xxx[cont/3-1]+pos[capa][0], 27*xxx[cont%3-1] + pos[capa][1]) )
                cont +=1
            imagen = pygame.image.load("capa%d.png" % capa)                        
            for pixel in pix:
                rgb = imagen.get_at(pixel)
                if HSL:
                    hls = colorsys.rgb_to_hls(*map(lambda x: x/255.0, rgb[0:3])) #RGB to HLS
                    self.capas[capa].append(hls[0])    #para guardar el hls
                else: 
                    self.capas[capa].append(rgb)    #para guardar el rgba
        return self.capas
     
     
    def rgbToHls(self):
        """Pasar de RGB a HSL"""
        for capas in range(6):
            for cap in range(9):
                hsl = colorsys.rgb_to_hls(*map(lambda x: x/255.0, self.capas[capas][cap][:3]))
                self.capas[capas][cap] = hsl
    
    def encontrarBlancos(self):
        for capas in range(6):
            for cap in range(9):
                print self.capas[capas][cap]
                    
    def coloresDelMedio(self):
        colores = []
        dist = []
        for centros in range(6):
            colores.append(self.capas[centros][4])
        
        for c in range(len(colores)):
            if colores[c][2] > x:
                x = colores[c][2]
                w = colores[c]
        print w, "Este es el blanco"
        print colores, "PARAR Y MIRAR"
        colores.sort()
        # 0 |--1--2--3--4--5--6--| 7 
        dist.append(colores[0])
        dist.append((colores[1]-colores[0])/2)
        dist.append((colores[2]-colores[1])/2)
        dist.append((colores[3]-colores[2])/2)
        dist.append((colores[4]-colores[3])/2)
        dist.append((colores[5]-colores[4])/2)
        dist.append((1-colores[5]))
        return colores, dist
    
    def coloresMedios(self):
        """Capturamos los 6 colores medios"""
        colores = []
        for cap in range(6):
            for c in range(9):
                colores.append(self.capas[cap][c])   #S --> 1 ,  L--> 0.36
        colores.sort()
        print colores
        colores = (colores[4], colores[13], colores[22], colores[31], colores[40], colores[49])
        return colores
        
        #rgb = colorsys.hls_to_rgb(*map(lambda x: x/255.0, self.capas[x][w][0:3])) #RGB to HLS
    
    def setColores(self, colores, distancia):        
        dist = distancia
        contad = []
        for cap in range(6):
            for c in range(9):
                contador = 0
                color = self.capas[cap][c]
                for num in range(len(colores)):
                    if color <= (colores[num] + dist[num+1]) and color >= (colores[num] - dist[num]):
                        self.capas[cap][c] = colores[num]
                        contador +=1
                        contad.append(num)
                if contador != 1:
                    print "Aqui hay algo que falla", contador
        contad.sort()
        print contad
        return self.capas
        
    def hToRgb(self):
        pass                
                
                

